import { ShadowMaterial, type WebGLProgramParameters } from "three";

const gaussMaterial = new ShadowMaterial()

gaussMaterial.onBeforeCompile = (shader: WebGLProgramParameters) => {
    // Изменяем фрагментный шейдер
    console.log(shader.fragmentShader)
    shader.fragmentShader = `
        float gaussian(float x, float sigma) {
            return (1.0 / (sqrt(2.0 * 3.14159265) * sigma)) * exp(-0.5 * (x * x) / (sigma * sigma));
        }
        ${shader.fragmentShader}`
        .replace(
            `#include <colorspace_fragment>`,
            `#include <colorspace_fragment>
            // Add Gaussian blur logic here
            vec4 blurColor = vec4(0.0);
            vec4 test = vec4(0.0);
            float totalWeight = 0.0;
            const int blurRadius = 1; // Adjust for more or less blur

            for (int x = -blurRadius; x <= blurRadius; x++) {
                for (int y = -blurRadius; y <= blurRadius; y++) {
                    // Используем gaussian для вычисления веса
                    float weight = gaussian(float(sqrt(float(x * x + y * y))), float(blurRadius));
                    // Получаем цвет текстуры с учетом смещения
                    blurColor += texture2D(pointShadowMap[0], gl_FragCoord.xy + vec2(float(x), float(y))) * weight;
                    totalWeight += weight;
                }
            }

            blurColor /= totalWeight;
            gl_FragColor = vec4(texture2D(pointShadowMap[0], vec2(-1.0,1.0)));

        `);
}

export default gaussMaterial